package com.realnet.basicp1.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basicp1.Entity.Country;
import com.realnet.basicp1.Services.CountryService ;




@RequestMapping(value = "/token/Country")
 @CrossOrigin("*") 
@RestController
public class tokenFree_CountryController {
	@Autowired
	private CountryService Service;

@Value("${projectPath}")
	private String projectPath;
 




	@PostMapping("/Country")
		  public Country Savedata(@RequestBody Country data) {
		Country save = Service.Savedata(data)	;



		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Country/{id}")
	public  Country update(@RequestBody Country data,@PathVariable Integer id ) {
		Country update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Country/getall/page")
	public Page<Country> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Country> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Country")
	public List<Country> getdetails() {
		 List<Country> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Country")
	public List<Country> getallwioutsec() {
		 List<Country> get = Service.getdetails();		
		return get;
}
@GetMapping("/Country/{id}")
	public  Country  getdetailsbyId(@PathVariable Integer id ) {
		Country  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Country/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}





}